package com.zswl.cloud.springBtach.server.core.controller;

import com.github.microservice.auth.client.content.ResultContent;
import com.github.microservice.auth.security.annotations.ResourceAuth;
import com.github.microservice.auth.security.type.AuthType;
import com.xiaoju.open.oil.commons.OilRequest;
import com.xiaoju.open.oil.core.executor.ResponseDTO;
import com.xiaoju.open.oil.interfaces.response.QueryApiStorePriceResponse;
import com.xiaoju.open.oil.interfaces.response.QueryCalBatchPriceResponse;
import com.xiaoju.open.oil.interfaces.response.QueryCalPriceResponse;
import com.xiaoju.open.oil.interfaces.response.QueryStoreDetailResponse;
import com.zswl.cloud.springBatch.client.model.request.NearbyModel;
import com.zswl.cloud.springBatch.client.model.request.QueryCalPriceModel;
import com.zswl.cloud.springBatch.client.model.request.QueryCalPricesModel;
import com.zswl.cloud.springBtach.server.core.domain.XiaoJuStore;
import com.zswl.cloud.springBtach.server.core.service.XiaoJuService;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Log4j2
@RestController
@RequestMapping("xiaoju")
public class XiaoJuController {

    @Autowired
    XiaoJuService xiaoJuService;

    @ApiOperation("推送-同步订单信息")
    @RequestMapping(value = "notifyOrderInfo", method = RequestMethod.POST)
    @ResourceAuth(value = "user", type = AuthType.User)
    public ResponseDTO notifyOrderInfo(@RequestBody OilRequest oilRequest) {

        return xiaoJuService.notifyOrderInfo(oilRequest);
    }
    @ApiOperation("推送-同步加油站信息")
    @RequestMapping(value = "receivingGasStation", method = RequestMethod.POST)
    @ResourceAuth(value = "user", type = AuthType.User)
    public ResponseDTO receivingGasStation(@RequestBody OilRequest oilRequest) {

        return xiaoJuService.notificationPushStoreInfoRequest(oilRequest);
    }
    @ApiOperation("查看附近的加油站信息")
    @ResourceAuth(value = "user", type = AuthType.User)
    @RequestMapping(value = "nearbyStore", method = RequestMethod.POST)
    public ResultContent<List<XiaoJuStore>> nearbyStore(@RequestBody NearbyModel nearbyModel) {
        return xiaoJuService.nearbyStore(nearbyModel);
    }
    @ApiOperation("查询门店价格")
    @ResourceAuth(value = "user", type = AuthType.User)
    @RequestMapping(value = "queryStorePrice", method = RequestMethod.POST)
    public ResultContent<List<QueryApiStorePriceResponse>> queryStorePrice(@RequestBody List<String> storeIdList) {
        return xiaoJuService.queryStorePrice(storeIdList);
    }
    @ApiOperation("查看加油站详情")
    @RequestMapping(value = "queryStoreDetail", method = RequestMethod.POST)
    @ResourceAuth(value = "user", type = AuthType.User)
    public ResultContent<QueryStoreDetailResponse> queryStoreDetail(String storeId) {

        return xiaoJuService.queryStoreDetail(storeId);
    }
    @ApiOperation("价格计算")
    @RequestMapping(value = "queryCalPrice", method = RequestMethod.POST)
    @ResourceAuth(value = "user", type = AuthType.User)
    public ResultContent<QueryCalPriceResponse> queryCalPrice(QueryCalPriceModel queryCalPriceModel) {
        return xiaoJuService.queryCalPrice(queryCalPriceModel);
    }
    @ApiOperation("批量价格计算")
    @RequestMapping(value = "queryCalPrices", method = RequestMethod.POST)
    @ResourceAuth(value = "user", type = AuthType.User)
    public ResultContent<QueryCalBatchPriceResponse> queryCalPrices(QueryCalPricesModel queryCalPriceModel) {
        return xiaoJuService.queryCalPrices(queryCalPriceModel);
    }


}
